/* make-Train.c: make <domain>.Train file for ga-cfp */

#include <stdio.h>
#include <string.h>
#include "ga-cfp.h"

int No_Classes;
int cp; /* class position */
int ipc; /* instances per class */
char domain[MAX_NAME], dataFileName[MAX_NAME], TrainFileName[MAX_NAME];

separator(ch)
char ch;
{
  if (ch == ' ' || ch == ',' || ch == '\t')
    return(1);
  else
    return(0);
}

char *read_next_value(into, from)
char *from, *into;
{
  int j;

  /* skip separators */
  while (separator(*from) && *from != '\0') from++;
  /* read the value into temp */
  j=0; 
  while (!separator(*from) && *from != ',') {
    into[j++]=*from;
    from++; 
  }
  into[j]='\0';			/* into contains a value as a string */
  return from;
}

void read_an_instance(i, line)
INSTANCE *i;
char *line;
{
  char value_in_string[MAX_LINE];
  int v, max_v = cp+1;

  for (v = 0;  v < max_v; v++) 
    line = read_next_value(value_in_string, line);
  /* now, it is the class value */
  if (strcmp(value_in_string, "?") == 0)
    i->class = UNDETERMINED;
  else 
    sscanf(value_in_string, "%d", &(i->class));
}

parse_options(argc,argv)
int argc;
char *argv[];
{
  strcpy(domain, argv[1]);
  sscanf(argv[2],"%d", &No_Classes); No_Classes++;
  sscanf(argv[3],"%d", &cp); /* class position */
  sscanf(argv[4],"%d", &ipc); /* ipc: instances per class */
  printf("domain:%s,No_classes:%d,cp:%d,ipc:%d\n",domain,No_Classes,cp,ipc);
}
  
main(argc, argv)
int argc;
char *argv[];
{
  FILE *fopen(), *dataf, *Trainf;
  INSTANCE i;
  char line[MAX_LINE];
  int inst_count[MAX_CLASSES];
  CLASS c;

  if (argc == 1) {
    printf("make-Train <domain> <max-class> <class-pos> <inst-per-class>\n");
    printf("There must not be any class label less than 0.\n");
    printf("positions in a line start from 0. \n");
    printf("If class is in the last position, <class-pos> = No_Features\n");
    exit(1);
  }

  parse_options(argc,argv);
  strcpy(dataFileName,domain);
  strcat(dataFileName,".data");
  strcpy(TrainFileName,domain);
  strcat(TrainFileName,".Train");
  dataf = fopen(dataFileName,"r");
  if (dataf==NULL) {
    fprintf(stderr,"cannot open data file %s\n", dataFileName);
    exit(1);
  }
  Trainf = fopen(TrainFileName, "w");
  for(c=0; c<No_Classes; inst_count[c++]=0); 
  
  while (fgets(line, MAX_LINE, dataf) != 0) {
    read_an_instance(&i, line);
    c = i.class;
    if (inst_count[c] < ipc) {
      fprintf(Trainf, "%s", line);
      inst_count[c]++;
    }
  }
  fclose(dataf);
  fclose(Trainf);
}
